(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define("ReactLocalRedux", ["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactLocalRedux"] = factory(require("react"));
	else
		root["ReactLocalRedux"] = factory(root["react"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_react__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./node_modules/fast-equals/es/comparator.js":
/*!***************************************************!*\
  !*** ./node_modules/fast-equals/es/comparator.js ***!
  \***************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./constants */ "./node_modules/fast-equals/es/constants.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ "./node_modules/fast-equals/es/utils.js");
// constants


// utils


var isArray = Array.isArray;

var areMapsEqual = Object(_utils__WEBPACK_IMPORTED_MODULE_1__["createAreIterablesEqual"])(true);
var areSetsEqual = Object(_utils__WEBPACK_IMPORTED_MODULE_1__["createAreIterablesEqual"])(false);

var createComparator = function createComparator(createIsEqual) {
  // eslint-disable-next-line no-use-before-define
  var isEqual = typeof createIsEqual === 'function' ? createIsEqual(comparator) : comparator;

  /**
   * @function comparator
   *
   * @description
   * compare the value of the two objects and return true if they are equivalent in values
   *
   * @param {any} objectA the object to test against
   * @param {any} objectB the object to test
   * @param {any} [meta] an optional meta object that is passed through to all equality test calls
   * @returns {boolean} are objectA and objectB equivalent in value
   */
  function comparator(objectA, objectB, meta) {
    if (Object(_utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"])(objectA, objectB)) {
      return true;
    }

    var typeOfA = typeof objectA;

    if (typeOfA !== typeof objectB || typeOfA !== 'object' || !objectA || !objectB) {
      return false;
    }

    if (Object(_utils__WEBPACK_IMPORTED_MODULE_1__["isPlainObject"])(objectA) && Object(_utils__WEBPACK_IMPORTED_MODULE_1__["isPlainObject"])(objectB)) {
      return Object(_utils__WEBPACK_IMPORTED_MODULE_1__["areObjectsEqual"])(objectA, objectB, isEqual, meta);
    }

    var arrayA = isArray(objectA);
    var arrayB = isArray(objectB);

    if (arrayA || arrayB) {
      return arrayA === arrayB && Object(_utils__WEBPACK_IMPORTED_MODULE_1__["areArraysEqual"])(objectA, objectB, isEqual, meta);
    }

    var dateA = objectA instanceof Date;
    var dateB = objectB instanceof Date;

    if (dateA || dateB) {
      return dateA === dateB && Object(_utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"])(objectA.getTime(), objectB.getTime());
    }

    var regexpA = objectA instanceof RegExp;
    var regexpB = objectB instanceof RegExp;

    if (regexpA || regexpB) {
      return regexpA === regexpB && Object(_utils__WEBPACK_IMPORTED_MODULE_1__["areRegExpsEqual"])(objectA, objectB);
    }

    if (Object(_utils__WEBPACK_IMPORTED_MODULE_1__["isPromiseLike"])(objectA) || Object(_utils__WEBPACK_IMPORTED_MODULE_1__["isPromiseLike"])(objectB)) {
      return objectA === objectB;
    }

    if (_constants__WEBPACK_IMPORTED_MODULE_0__["HAS_MAP_SUPPORT"]) {
      var mapA = objectA instanceof Map;
      var mapB = objectB instanceof Map;

      if (mapA || mapB) {
        return mapA === mapB && areMapsEqual(objectA, objectB, isEqual, meta);
      }
    }

    if (_constants__WEBPACK_IMPORTED_MODULE_0__["HAS_SET_SUPPORT"]) {
      var setA = objectA instanceof Set;
      var setB = objectB instanceof Set;

      if (setA || setB) {
        return setA === setB && areSetsEqual(objectA, objectB, isEqual, meta);
      }
    }

    return Object(_utils__WEBPACK_IMPORTED_MODULE_1__["areObjectsEqual"])(objectA, objectB, isEqual, meta);
  }

  return comparator;
};

/* harmony default export */ __webpack_exports__["default"] = (createComparator);

/***/ }),

/***/ "./node_modules/fast-equals/es/constants.js":
/*!**************************************************!*\
  !*** ./node_modules/fast-equals/es/constants.js ***!
  \**************************************************/
/*! exports provided: HAS_MAP_SUPPORT, HAS_SET_SUPPORT, HAS_WEAKSET_SUPPORT */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HAS_MAP_SUPPORT", function() { return HAS_MAP_SUPPORT; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HAS_SET_SUPPORT", function() { return HAS_SET_SUPPORT; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HAS_WEAKSET_SUPPORT", function() { return HAS_WEAKSET_SUPPORT; });
/**
 * @constant {boolean} HAS_MAP_SUPPORT
 */
var HAS_MAP_SUPPORT = typeof Map === 'function';

/**
 * @constant {boolean} HAS_SET_SUPPORT
 */
var HAS_SET_SUPPORT = typeof Set === 'function';

/**
 * @constant {boolean} HAS_WEAKSET_SUPPORT
 */
var HAS_WEAKSET_SUPPORT = typeof WeakSet === 'function';

/***/ }),

/***/ "./node_modules/fast-equals/es/index.js":
/*!**********************************************!*\
  !*** ./node_modules/fast-equals/es/index.js ***!
  \**********************************************/
/*! exports provided: createCustomEqual, sameValueZeroEqual, circularDeepEqual, circularShallowEqual, deepEqual, shallowEqual, default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "circularDeepEqual", function() { return circularDeepEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "circularShallowEqual", function() { return circularShallowEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deepEqual", function() { return deepEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "shallowEqual", function() { return shallowEqual; });
/* harmony import */ var _comparator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./comparator */ "./node_modules/fast-equals/es/comparator.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "createCustomEqual", function() { return _comparator__WEBPACK_IMPORTED_MODULE_0__["default"]; });

/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ "./node_modules/fast-equals/es/utils.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sameValueZeroEqual", function() { return _utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"]; });

// comparator


// utils




var circularDeepEqual = Object(_comparator__WEBPACK_IMPORTED_MODULE_0__["default"])(Object(_utils__WEBPACK_IMPORTED_MODULE_1__["createCircularEqual"])());
var circularShallowEqual = Object(_comparator__WEBPACK_IMPORTED_MODULE_0__["default"])(Object(_utils__WEBPACK_IMPORTED_MODULE_1__["createCircularEqual"])(_utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"]));
var deepEqual = Object(_comparator__WEBPACK_IMPORTED_MODULE_0__["default"])();
var shallowEqual = Object(_comparator__WEBPACK_IMPORTED_MODULE_0__["default"])(function () {
  return _utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"];
});

/* harmony default export */ __webpack_exports__["default"] = ({
  circularDeep: circularDeepEqual,
  circularShallow: circularShallowEqual,
  createCustom: _comparator__WEBPACK_IMPORTED_MODULE_0__["default"],
  deep: deepEqual,
  sameValueZero: _utils__WEBPACK_IMPORTED_MODULE_1__["sameValueZeroEqual"],
  shallow: shallowEqual
});

/***/ }),

/***/ "./node_modules/fast-equals/es/utils.js":
/*!**********************************************!*\
  !*** ./node_modules/fast-equals/es/utils.js ***!
  \**********************************************/
/*! exports provided: addObjectToCache, hasItem, hasItems, sameValueZeroEqual, isPlainObject, isPromiseLike, isReactElement, getNewCache, createCircularEqual, toPairs, areArraysEqual, createAreIterablesEqual, areObjectsEqual, areRegExpsEqual */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addObjectToCache", function() { return addObjectToCache; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hasItem", function() { return hasItem; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hasItems", function() { return hasItems; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sameValueZeroEqual", function() { return sameValueZeroEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isPlainObject", function() { return isPlainObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isPromiseLike", function() { return isPromiseLike; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isReactElement", function() { return isReactElement; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNewCache", function() { return getNewCache; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createCircularEqual", function() { return createCircularEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toPairs", function() { return toPairs; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "areArraysEqual", function() { return areArraysEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createAreIterablesEqual", function() { return createAreIterablesEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "areObjectsEqual", function() { return areObjectsEqual; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "areRegExpsEqual", function() { return areRegExpsEqual; });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./constants */ "./node_modules/fast-equals/es/constants.js");
// constants


var keys = Object.keys;

/**
 * @function addObjectToCache
 *
 * @description
 * add object to cache if it is indeed an object
 *
 * @param {any} object the object to potentially add to the cache
 * @param {Object|WeakSet} cache the cache to add to
 * @returns {void}
 */
var addObjectToCache = function addObjectToCache(object, cache) {
  return object && typeof object === 'object' && cache.add(object);
};

/**
 * @function hasItem
 *
 * @description
 * does the array include the item passed
 *
 * @param {Array<any>} array the array to check in
 * @param {any} item the item to locate
 * @param {function} isEqual the equality comparator
 * @param {any} meta the meta item to pass through
 * @returns {boolean} does the item exist in the array
 */
var hasItem = function hasItem(array, item, isEqual, meta) {
  for (var index = 0; index < array.length; index++) {
    if (isEqual(array[index], item, meta)) {
      return true;
    }
  }

  return false;
};

/**
 * @function hasItems
 *
 * @description
 * are the arrays equal in value, despite being in different order
 *
 * @param {Array<any>} arrayA the first array to test
 * @param {Array<any>} arrayB the second array to test
 * @param {function} isEqual the equality comparator
 * @param {any} meta the meta item to pass through
 * @returns {boolean} are the arrays equal absent order
 */
var hasItems = function hasItems(arrayA, arrayB, isEqual, meta) {
  if (arrayA.length !== arrayB.length) {
    return false;
  }

  for (var index = 0; index < arrayA.length; index++) {
    if (!hasItem(arrayB, arrayA[index], isEqual, meta)) {
      return false;
    }
  }

  return true;
};

/**
 * @function sameValueZeroEqual
 *
 * @description
 * are the objects passed strictly equal or both NaN
 *
 * @param {any} objectA the object to compare against
 * @param {any} objectB the object to test
 * @returns {boolean} are the objects equal by the SameValueZero principle
 */
var sameValueZeroEqual = function sameValueZeroEqual(objectA, objectB) {
  return objectA === objectB || objectA !== objectA && objectB !== objectB;
};

/**
 * @function isPlainObject
 *
 * @description
 * is the object a plain object
 *
 * @param {any} object the object to test
 * @returns {boolean} is the object a plain object
 */
var isPlainObject = function isPlainObject(object) {
  return object.constructor === Object;
};

/**
 * @function isPromiseLike
 *
 * @description
 * is the object promise-like (thenable)
 *
 * @param {any} object the object to test
 * @returns {boolean} is the object promise-like
 */
var isPromiseLike = function isPromiseLike(object) {
  return typeof object.then === 'function';
};

/**
 * @function isReactElement
 *
 * @description
 * is the object passed a react element
 *
 * @param {any} object the object to test
 * @returns {boolean} is the object a react element
 */
var isReactElement = function isReactElement(object) {
  return !!(object.$$typeof && object._store);
};

/**
 * @function getNewCache
 *
 * @description
 * get a new cache object to prevent circular references
 *
 * @returns {Object|Weakset} the new cache object
 */
var getNewCache = function getNewCache() {
  return _constants__WEBPACK_IMPORTED_MODULE_0__["HAS_WEAKSET_SUPPORT"] ? new WeakSet() : Object.create({
    _values: [],
    add: function add(value) {
      this._values.push(value);
    },
    has: function has(value) {
      return !!~this._values.indexOf(value);
    }
  });
};

/**
 * @function createCircularEqual
 *
 * @description
 * create a custom isEqual handler specific to circular objects
 *
 * @param {funtion} [isEqual] the isEqual comparator to use instead of isDeepEqual
 * @returns {function(any, any): boolean}
 */
var createCircularEqual = function createCircularEqual(isEqual) {
  return function (isDeepEqual) {
    var comparator = isEqual || isDeepEqual;

    return function (objectA, objectB) {
      var cache = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : getNewCache();

      var cacheHasA = cache.has(objectA);
      var cacheHasB = cache.has(objectB);

      if (cacheHasA || cacheHasB) {
        return cacheHasA && cacheHasB;
      }

      addObjectToCache(objectA, cache);
      addObjectToCache(objectB, cache);

      return comparator(objectA, objectB, cache);
    };
  };
};

/**
 * @function toPairs
 *
 * @param {Map|Set} iterable the iterable to convert to [key, value] pairs (entries)
 * @returns {{keys: Array<*>, values: Array<*>}} the [key, value] pairs
 */
var toPairs = function toPairs(iterable) {
  var pairs = {
    keys: [],
    values: []
  };

  iterable.forEach(function (value, key) {
    return pairs.keys.push(key) && pairs.values.push(value);
  });

  return pairs;
};

/**
 * @function areArraysEqual
 *
 * @description
 * are the arrays equal in value
 *
 * @param {Array<any>} arrayA the array to test
 * @param {Array<any>} arrayB the array to test against
 * @param {function} isEqual the comparator to determine equality
 * @param {any} meta the meta object to pass through
 * @returns {boolean} are the arrays equal
 */
var areArraysEqual = function areArraysEqual(arrayA, arrayB, isEqual, meta) {
  if (arrayA.length !== arrayB.length) {
    return false;
  }

  for (var index = 0; index < arrayA.length; index++) {
    if (!isEqual(arrayA[index], arrayB[index], meta)) {
      return false;
    }
  }

  return true;
};

var createAreIterablesEqual = function createAreIterablesEqual(shouldCompareKeys) {
  /**
   * @function areIterablesEqual
   *
   * @description
   * determine if the iterables are equivalent in value
   *
   * @param {Array<Array<any>>} pairsA the pairs to test
   * @param {Array<Array<any>>} pairsB the pairs to test against
   * @param {function} isEqual the comparator to determine equality
   * @param {any} meta the cache possibly being used
   * @returns {boolean} are the objects equal in value
   */
  var areIterablesEqual = shouldCompareKeys ? function (pairsA, pairsB, isEqual, meta) {
    return hasItems(pairsA.keys, pairsB.keys, isEqual, meta) && hasItems(pairsA.values, pairsB.values, isEqual, meta);
  } : function (pairsA, pairsB, isEqual, meta) {
    return hasItems(pairsA.values, pairsB.values, isEqual, meta);
  };

  return function (iterableA, iterableB, isEqual, meta) {
    return areIterablesEqual(toPairs(iterableA), toPairs(iterableB), isEqual, meta);
  };
};

/**
 * @function areArraysEqual
 *
 * @description
 * are the objects equal in value
 *
 * @param {Array<any>} objectA the object to test
 * @param {Array<any>} objectB the object to test against
 * @param {function} isEqual the comparator to determine equality
 * @param {any} meta the meta object to pass through
 * @returns {boolean} are the objects equal
 */
var areObjectsEqual = function areObjectsEqual(objectA, objectB, isEqual, meta) {
  var keysA = keys(objectA);
  var keysB = keys(objectB);

  if (keysA.length !== keysB.length) {
    return false;
  }

  var key = void 0;

  for (var index = 0; index < keysA.length; index++) {
    key = keysA[index];

    if (!hasItem(keysB, key, sameValueZeroEqual)) {
      return false;
    }

    // if a react element, ignore the "_owner" key because its not necessary for equality comparisons
    if (key === '_owner' && isReactElement(objectA) && isReactElement(objectB)) {
      continue;
    }

    if (!isEqual(objectA[key], objectB[key], meta)) {
      return false;
    }
  }

  return true;
};

/**
 * @function areRegExpsEqual
 *
 * @description
 * are the regExps equal in value
 *
 * @param {RegExp} regExpA the regExp to test
 * @param {RegExp} regExpB the regExp to test agains
 * @returns {boolean} are the regExps equal
 */
var areRegExpsEqual = function areRegExpsEqual(regExpA, regExpB) {
  return regExpA.source === regExpB.source && regExpA.global === regExpB.global && regExpA.ignoreCase === regExpB.ignoreCase && regExpA.multiline === regExpB.multiline && regExpA.unicode === regExpB.unicode && regExpA.sticky === regExpB.sticky && regExpA.lastIndex === regExpB.lastIndex;
};

/***/ }),

/***/ "./src/connectLocal.js":
/*!*****************************!*\
  !*** ./src/connectLocal.js ***!
  \*****************************/
/*! exports provided: createDispatch, createGetState, createShouldComponentUpdate, getActionCreators, onConstruct, connectLocal */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createDispatch", function() { return createDispatch; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createGetState", function() { return createGetState; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createShouldComponentUpdate", function() { return createShouldComponentUpdate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getActionCreators", function() { return getActionCreators; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onConstruct", function() { return onConstruct; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "connectLocal", function() { return connectLocal; });
/* harmony import */ var fast_equals__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! fast-equals */ "./node_modules/fast-equals/es/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./constants */ "./src/constants.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./utils */ "./src/utils.js");
// external dependencies

 // constants

 // utils


/**
 * @function createDispatch
 *
 * @description
 * create the dispatch method for the component
 *
 * @param {ReactComponent} instance the component instance
 * @param {function} reducer the reducer method
 * @returns {function(Object): void} the dispatch method for the component
 */

var createDispatch = function createDispatch(instance, reducer) {
  var dispatch = function dispatch(action) {
    instance.__state = reducer(instance.__state, action);
    instance.setState(function () {
      return instance.__state;
    });
    return action;
  };

  var middlewareApi = {
    dispatch: dispatch,
    getState: instance.getState
  };
  return Object(_utils__WEBPACK_IMPORTED_MODULE_3__["composeMiddleware"])(instance.options.middlewares.map(function (middleware) {
    return middleware(middlewareApi);
  }))(dispatch);
};
var createGetState = function createGetState(instance) {
  return (
    /**
     * @function getState
     *
     * @description
     * get the current state of the component
     *
     * @returns {Object} the current state
     */
    function () {
      return instance.__state;
    }
  );
};
var createShouldComponentUpdate = function createShouldComponentUpdate(instance) {
  return (
    /**
     * @function shouldComponentUpdate
     *
     * @description
     * determine whether the component should update based on the options provided
     *
     * @param {Object} nextProps the next props of the component
     * @param {Object} nextState the next reducer values
     * @param {Object} nextContext the next context of the component
     * @returns {boolean} should the component update
     */
    function (nextProps, nextState, nextContext) {
      var actionCreators = instance.actionCreators,
          context = instance.context,
          _instance$options = instance.options,
          areMergedPropsEqual = _instance$options.areMergedPropsEqual,
          areOwnPropsEqual = _instance$options.areOwnPropsEqual,
          areStatesEqual = _instance$options.areStatesEqual,
          mergeProps = _instance$options.mergeProps,
          pure = _instance$options.pure,
          props = instance.props,
          state = instance.state;

      if (!pure) {
        return true;
      }

      return !areOwnPropsEqual(props, nextProps) || !areStatesEqual(state, nextState) || !Object(fast_equals__WEBPACK_IMPORTED_MODULE_0__["shallowEqual"])(context, nextContext) || !areMergedPropsEqual( // eslint workaround
      mergeProps(state, actionCreators, props), mergeProps(nextState, actionCreators, nextProps));
    }
  );
};
/**
 * @function getActionCreators
 *
 * @description
 * get the actionCreators wrapped with the dispatch method
 *
 * @param {Object} actionCreators the actionCreators to wrap
 * @param {function} dispatch the instance-specific dispatch function
 * @returns {Object} the wrapped actionCreators
 */

var getActionCreators = function getActionCreators(actionCreators, dispatch) {
  return Object(_utils__WEBPACK_IMPORTED_MODULE_3__["reduce"])(Object.keys(actionCreators), function (wrappedActionCreators, name) {
    wrappedActionCreators[name] = function () {
      return dispatch(actionCreators[name].apply(actionCreators, arguments));
    };

    return wrappedActionCreators;
  }, {});
};
/**
 * @function onConstruct
 *
 * @description
 * on construction of the instance, set the options and the instance-specific methods
 *
 * @param {ReactComponent} instance the component instance
 * @param {function} reducer the reducer with state
 * @param {Object} actionCreators the actionCreators to wrap with dispatch
 * @param {Object} options additional options for the component
 */

var onConstruct = function onConstruct(instance, reducer, actionCreators, options) {
  // state
  instance.state = reducer(undefined, {});
  instance.__state = instance.state; // options

  instance.options = Object(_utils__WEBPACK_IMPORTED_MODULE_3__["assign"])({}, _constants__WEBPACK_IMPORTED_MODULE_2__["DEFAULT_OPTIONS"], options); // lifecycle methods

  instance.shouldComponentUpdate = createShouldComponentUpdate(instance); // instance methods

  instance.getState = createGetState(instance);
  instance.dispatch = createDispatch(instance, reducer); // instance values

  instance.actionCreators = actionCreators ? getActionCreators(actionCreators, instance.dispatch) : {
    dispatch: instance.dispatch
  };
};
/**
 * @function connectLocal
 *
 * @description
 * decorate a component with a higher-order component that manages local state
 * in the way that redux manages global state
 *
 * @param {function} reducer the reducer with state
 * @param {Object} actionCreators the actionCreators to wrap with dispatch
 * @param {Object} options additional options for the component
 * @returns {function}
 */

var connectLocal = function connectLocal(reducer, actionCreators, options) {
  return (
    /**
     * @function ConnectedLocalComponent
     *
     * @description
     * higher-order component decorator which adds a redux-like manager for local state
     *
     * @param {ReactComponent} ComponentToConnect the component being wrapped
     * @returns {ReactComponent} the higher-order component
     */
    function (ComponentToConnect) {
      function ConnectedLocalComponent(initialProps) {
        react__WEBPACK_IMPORTED_MODULE_1__["Component"].call(this, initialProps);
        onConstruct(this, reducer, actionCreators, options);

        this.render = function () {
          return Object(react__WEBPACK_IMPORTED_MODULE_1__["createElement"])(ComponentToConnect, this.options.mergeProps(this.state, this.actionCreators, this.props));
        };

        return this;
      }

      ConnectedLocalComponent.prototype = Object.create(react__WEBPACK_IMPORTED_MODULE_1__["Component"].prototype);
      ConnectedLocalComponent.displayName = "ConnectedLocal(" + Object(_utils__WEBPACK_IMPORTED_MODULE_3__["getDisplayName"])(ComponentToConnect) + ")";
      return ConnectedLocalComponent;
    }
  );
};

/***/ }),

/***/ "./src/constants.js":
/*!**************************!*\
  !*** ./src/constants.js ***!
  \**************************/
/*! exports provided: DEFAULT_OPTIONS */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DEFAULT_OPTIONS", function() { return DEFAULT_OPTIONS; });
/* harmony import */ var fast_equals__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! fast-equals */ "./node_modules/fast-equals/es/index.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ "./src/utils.js");
// external dependencies
 // utils


/**
 * @constant {Object} DEFAULT_OPTIONS
 */

var DEFAULT_OPTIONS = {
  areMergedPropsEqual: fast_equals__WEBPACK_IMPORTED_MODULE_0__["shallowEqual"],
  areOwnPropsEqual: fast_equals__WEBPACK_IMPORTED_MODULE_0__["shallowEqual"],
  areStatesEqual: fast_equals__WEBPACK_IMPORTED_MODULE_0__["shallowEqual"],
  mergeProps: _utils__WEBPACK_IMPORTED_MODULE_1__["getMergedProps"],
  middlewares: [],
  pure: true
};

/***/ }),

/***/ "./src/helperMethods.js":
/*!******************************!*\
  !*** ./src/helperMethods.js ***!
  \******************************/
/*! exports provided: createActionCreator, createReducer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createActionCreator", function() { return createActionCreator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createReducer", function() { return createReducer; });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./utils */ "./src/utils.js");
// utils

/**
 * @function createAction
 *
 * @description
 * create an action creator based on the parameters passed
 *
 * @param {string} type the type of action being dispatched
 * @param {function} [payloadHandler=identity] the function to get the payload value
 * @param {function} [metaHandler=noop] the function to get the meta value
 * @returns {function(...any): Object} the actionCreator
 */

var createActionCreator = function createActionCreator(type, payloadHandler, metaHandler) {
  if (payloadHandler === void 0) {
    payloadHandler = _utils__WEBPACK_IMPORTED_MODULE_0__["identity"];
  }

  if (metaHandler === void 0) {
    metaHandler = _utils__WEBPACK_IMPORTED_MODULE_0__["noop"];
  }

  if (typeof type !== 'string') {
    throw new ReferenceError('The action type passed must be a string.');
  }

  if (typeof payloadHandler !== 'function') {
    throw new ReferenceError('The payload handler passed must be a function.');
  }

  if (typeof metaHandler !== 'function') {
    throw new ReferenceError('The meta handler passed must be a function.');
  }

  var actionCreator = function actionCreator() {
    var action = {
      type: type
    };
    var payload = payloadHandler.apply(void 0, arguments);

    if (!Object(_utils__WEBPACK_IMPORTED_MODULE_0__["isUndefined"])(payload)) {
      action.payload = payload;

      if (payload instanceof Error) {
        action.error = true;
      }
    }

    var meta = metaHandler.apply(void 0, arguments);

    if (!Object(_utils__WEBPACK_IMPORTED_MODULE_0__["isUndefined"])(meta)) {
      action.meta = meta;
    }

    return action;
  };

  actionCreator.toString = function () {
    return type;
  };

  return actionCreator;
};
/**
 * @function createReducer
 *
 * @description
 * based on the handlers and initial state passed, build a reducer function
 *
 * @param {Object} handlers the handlers to build the reducer from
 * @param {Object} initialState the initial state of the reducer
 * @returns {function(Object, Object): Object} the reducer for the component
 */

var createReducer = function createReducer(handlers, initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  if (typeof handlers === 'function') {
    return handlers;
  }

  if (typeof handlers !== 'object') {
    throw new ReferenceError('The handlers passed must be an object.');
  }

  return function (state, action) {
    if (state === void 0) {
      state = initialState;
    }

    var handler = handlers[action.type];
    return handler ? handler(state, action) : state;
  };
};

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! exports provided: connectLocal, createActionCreator, createReducer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _connectLocal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./connectLocal */ "./src/connectLocal.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "connectLocal", function() { return _connectLocal__WEBPACK_IMPORTED_MODULE_0__["connectLocal"]; });

/* harmony import */ var _helperMethods__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helperMethods */ "./src/helperMethods.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "createActionCreator", function() { return _helperMethods__WEBPACK_IMPORTED_MODULE_1__["createActionCreator"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "createReducer", function() { return _helperMethods__WEBPACK_IMPORTED_MODULE_1__["createReducer"]; });

// decorators
 // helpers




/***/ }),

/***/ "./src/utils.js":
/*!**********************!*\
  !*** ./src/utils.js ***!
  \**********************/
/*! exports provided: identity, isUndefined, noop, reduce, assign, composeMiddleware, getFunctionNameRegexp, getDisplayName, getMergedProps */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "identity", function() { return identity; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isUndefined", function() { return isUndefined; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "noop", function() { return noop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reduce", function() { return reduce; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "assign", function() { return assign; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "composeMiddleware", function() { return composeMiddleware; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getFunctionNameRegexp", function() { return getFunctionNameRegexp; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getDisplayName", function() { return getDisplayName; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getMergedProps", function() { return getMergedProps; });
/**
 * @function identity
 *
 * @description
 * return the first value passed
 *
 * @param {any} value the value to return
 * @returns {any} the first parameter passed
 */
var identity = function identity(value) {
  return value;
};
/**
 * @function isUndefined
 *
 * @description
 * is the value passed undefined
 *
 * @param {any} value the value to test
 * @returns {boolean} is the value passed undefined
 */

var isUndefined = function isUndefined(value) {
  return value === void 0;
};
/**
 * @function noop
 *
 * @description
 * return nothing regardless of what is passed
 *
 * @returns {void}
 */

var noop = function noop() {};
/**
 * @function reduce
 *
 * @description
 * reduce the array to a single value
 *
 * @param {Array<any>} array the array to reduce
 * @param {function} fn the function called with each iteration
 * @param {any} initialValue the initial value of the reduction
 * @returns {any} the reduced value
 */

var reduce = function reduce(array, fn, initialValue) {
  var value = initialValue;

  for (var index = 0; index < array.length; index++) {
    value = fn(value, array[index], index, array);
  }

  return value;
};
/**
 * @function assign
 *
 * @description
 * shallowly merge the sources into the target object
 *
 * @param {Object} target the target object to merge into
 * @param  {...Object} sources the source objects to merge into target
 * @returns {Object} the merged object
 */

var assign = function assign(target) {
  for (var _len = arguments.length, sources = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    sources[_key - 1] = arguments[_key];
  }

  return reduce(sources, function (assigned, source) {
    return typeof source === 'object' ? reduce(Object.keys(source), function (assignedSource, key) {
      assignedSource[key] = source[key];
      return assignedSource;
    }, assigned) : assigned;
  }, target);
};
/**
 * @function composeMiddleware
 *
 * @description
 * compose the middleware functions to a single function
 *
 * @param {Array<function>} fns the middleware functions to compose
 * @returns {function} the composed middleware
 */

var composeMiddleware = function composeMiddleware(fns) {
  if (!fns.length) {
    return identity;
  }

  if (fns.length === 1) {
    return fns[0];
  }

  var last = fns.splice(fns.length - 1, 1)[0];
  return function () {
    return reduce(fns.reverse(), function (composed, f) {
      return f(composed);
    }, last.apply(void 0, arguments));
  };
};
/**
 * @function getFunctionNameRegexp
 *
 * @description
 * using regexp derivation of the function's toString value, get the function name
 *
 * @param {function} fn the function to derive the name from
 * @returns {string} the function name
 */

var getFunctionNameRegexp = function getFunctionNameRegexp(fn) {
  return (/\W*function\s+([\w\$]+)\(/.exec("" + fn) || [])[1];
};
/**
 * @function getDisplayName
 *
 * @description
 * get the displayName of the component, either directly or derived
 *
 * @param {ReactComponent} Component the component to get the displayName for
 * @returns {string} the displayName
 */

var getDisplayName = function getDisplayName(Component) {
  return Component.displayName || Component.name || getFunctionNameRegexp(Component) || 'Component';
};
/**
 * @function getMergedProps
 *
 * @description
 * get the state, actionCreators, and props merged into a single props object to pass
 *
 * @param {Object} stateProps the state of the reducer
 * @param {Object} dispatchProps the wrapped action creators
 * @param {Object} ownProps the props passed directly to the component
 * @returns {Object} the merged props
 */

var getMergedProps = function getMergedProps(stateProps, dispatchProps, ownProps) {
  return assign({}, ownProps, stateProps, dispatchProps);
};

/***/ }),

/***/ 0:
/*!****************************!*\
  !*** multi ./src/index.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! /home/tquetano/git/react-local-redux/src/index.js */"./src/index.js");


/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_react__;

/***/ })

/******/ });
});
//# sourceMappingURL=react-local-redux.js.map